Program CHKSUM;
uses dos;
Var dir     : searchrec;
    chks    : word;
    Block   : array [1..32768] of byte;
    D,DD    : DirStr;
    N       : NameStr;
    E       : ExtStr;
    f       : file;
    chaine,
    chaine2 : string;
    Taille  : longint;
    date    : datetime;

Function hex (b:byte):char;
begin
 Case b of
 0 : hex:='0';
 1 : hex:='1';
 2 : hex:='2';
 3 : hex:='3';
 4 : hex:='4';
 5 : hex:='5';
 6 : hex:='6';
 7 : hex:='7';
 8 : hex:='8';
 9 : hex:='9';
 10: hex:='A';
 11: hex:='B';
 12: hex:='C';
 13: hex:='D';
 14: hex:='E';
 15: hex:='F';
 else hex:='0';
 end;
end;

Function CHK_sum(var f:file):word;
Var CHKS   : word;
    Lus    : word;
    I      : word;

Begin
  CHKS:=0;
  Repeat
    Blockread(f,block,32768,lus);
    For I:=1 to lus do Chks:=chks+block[I];
  Until lus < 32768;
  chk_sum:=chks;
End;



Begin
 Writeln('CHKSUM V1.1  *** Copyright Robert CHERAMY 1997 ***  CHKSUM /? for Help');
 Writeln;
 chaine:=paramstr(1);

 if chaine='/?' then
  begin
   Writeln('This program is Cardware which means that if you like it,');
   Writeln('you must send me a postcard or a message at:');
   Writeln('Robert CHERAMY           or         rcheramy@mail.dotcom.fr');
   Writeln('54, rue de Sours');
   Writeln('28000 CHARTRES');
   Writeln('FRANCE');
   Writeln;
   Writeln('Usage: chksum /?            for this help');
   Writeln('       chksum [filespec]    to compute the Check Sum of filespec (default: *.*)');
   Writeln('filespec can be a path, and use the usual DOS wildcards (* and ?)');
   Halt(1);
  end;

 if chaine='' then chaine:='*.*';

 Filemode:=0;
 FSplit(chaine,D,N,E);

 If N+E='' then chaine:=chaine+'*.*';
 If ( ((E='.') or (E='..'))  and (N='')) then chaine := chaine+'\*.*';

 Findfirst(chaine,$27,dir);

 If doserror<>0 then
   begin
     Findfirst(chaine,Anyfile,dir);
     If (doserror<>0) then
       begin
         Writeln('File not found');
         Halt(0);
       End;
     chaine:=D+dir.name+'\*.*';
     Findfirst(chaine,$27,dir);
     If doserror<>0 then
      begin
       Writeln('File not found');
       Halt(0);
      end;
   End;
 Fsplit(chaine,D,N,E);


 WHILE DosError = 0 DO
  BEGIN
    Fsplit(Dir.name,DD,N,E);
    While length(N)<8 do N:=N+' ';
    While length(E)<4 do E:=E+' ';
    Write(N+E,'  ');

    {$I-}
    Assign(f,D+dir.Name);
    Reset(f,1);
    {$I+};
    If IOResult<>0 then Write('#----')
      else begin
        chks:=chk_sum(f);
        Close(f);
        Write('#',hex(chks shr 12),hex($F and (chks shr 8)));
        Write(hex($F and (chks shr 4)),hex($F and chks));
      end;

    Write(' ');

    taille:=dir.size;
    chaine:='';
    While taille>1000 do
     Begin
      str(taille mod 1000,chaine2);
      While length(chaine2)<3 do chaine2:='0'+chaine2;
      chaine:=chaine2+' '+chaine;
      taille:=taille div 1000;
     End;
    str(taille,chaine2);
    chaine:=chaine2+' '+chaine;
    While length(chaine)<11 do chaine:=' '+chaine;
    Write(chaine);

    UnPackTime(dir.time,Date);

    str(date.day,chaine);
    While length(chaine)<2 do chaine:='0'+chaine;

    str(date.month,chaine2);
    While length(chaine2)<2 do chaine2:='0'+chaine2;
    chaine:=chaine+'.'+chaine2;

    str(date.year,chaine2);
    Delete(chaine2,1,2);
    chaine:=chaine+'.'+chaine2;

    str(date.hour,chaine2);
    While length(chaine2)<2 do chaine2:='0'+chaine2;
    chaine:=chaine+'  '+chaine2;

    str(date.min,chaine2);
    While length(chaine2)<2 do chaine2:='0'+chaine2;
    chaine:=chaine+'.'+chaine2;

    Write('  ',chaine,' ');

    If (dir.attr and Hidden)<>0   then write('H') else write('-');
    If (dir.attr and Sysfile)<>0  then write('S') else write('-');
    If (dir.attr and Readonly)<>0 then write('R') else write('-');
    If (dir.attr and Archive)<>0  then writeln('A') else writeln('-');


    Findnext(dir);
  END;
End.

